Whamcloud - gitweb
b:11171, 10961
[fs/lustre-release.git] / lustre-iokit / obdfilter-survey / obdfilter-survey
index f700a88..9e8eb33 100755 (executable)
 ######################################################################
 # customize per survey
 
-# specify either the obdecho client names or the obdfilter names
-client_names=()
-ost_names=(ost{1,2,3,4,5,6,7,8})
-
-# result file prefix
-rslt=/tmp/obdfilter_survey
-
-# lustre root (leave blank unless running with own source)
-lustre_root=
-
-# what to do (we always do an initial write)
-#tests="rewrite read reread rewrite_again"
-tests="rewrite read"
-
-# total size (MBytes)
-# large enough to avoid cache effects
-size=8192
-
-# record size (KBytes)
-rszlo=1024
-rszhi=1024
+# specify obd instances to exercise
+# these can be either...
+# obdfilter instances (set 'ost_names')
+# ...or...
+# echo_client instances (set 'client_names')
+# ... use 'host:name' for obd instances on other nodes.
+# allow these to be passed in via string...
+# OR
+# one can specify only case=disk or case=network or case=netdisk through 
+# command line.
+
+# Perquisite: For "disk" case and "netdisk" case you need to have lustre setup
+#             with one or more ost's. For "network" case  you need to have all
+#             modules (those llmount.sh loades) loaded in kernel. And the 
+#             'lctl dl' output must be blank.
+
+# How to run test:
+# case 1 (local disk):
+#   $ nobjhi=2 thrhi=2 size=1024 case=disk sh obdfilter-survey
+#   one can also run test with user defined targets as follows,
+#   $ nobjhi=2 thrhi=2 size=1024 targets="lustre-OST0000 lustre-OST0001 ..." sh obdfilter-survey
+# case 2 (network):
+#   $ nobjhi=2 thrhi=2 size=1024 targets="<name/ip_of_server>" case=network sh obdfilter-survey
+#   where, targets is name or ip address of system, which you want to 
+#   set as server.
+# case 3 (network and disk):
+#   $ nobjhi=2 thrhi=2 size=1024 case=netdisk sh obdfilter-survey
+#   one can also run test with user defined targets as follows,
+#   $ nobjhi=2 thrhi=2 size=1024 targets="<osc_name> ..." sh obdfilter-survey
+#[ NOTE: It is advised to have automated login (passwordless entry) between server and 
+#  client systems on which this test runs.]
+
+# include library 
+source libecho
+
+# The following variables can be set in the environment, or on the
+# command line
+# result file prefix (date/time + hostname makes unique)
+# NB ensure path to it exists
+rslt_loc=${rslt_loc:-"/tmp"}
+rslt=${rslt:-"$rslt_loc/obdfilter_survey_`date +%F@%R`_`uname -n`"}
+
+# Set this true to check file contents
+verify=${verify:-0}
+
+# total size (MBytes) per obd instance
+# large enough to avoid cache effects 
+# and to make test startup/shutdown overhead insignificant
+size=${size:-16384}
+
+# record size (KBytes) ( 7168 max)
+rszlo=${rszlo:-1024}
+rszhi=${rszhi:-1024}
 
 # number of objects per OST
-nobjlo=1
-nobjhi=32
+nobjlo=${nobjlo:-1}
+#was nobjhi=${nobjhi:-512}
+nobjhi=${nobjhi:-16}
 
 # threads per OST (1024 max)
-thrlo=1
-thrhi=128
-
-# restart from here iff all are defined
-restart_rsz=
-restart_thr=1
-restart_nobj=1
-
-# machine's page size
-PAGE_SIZE=64
-
-# max buffer_mem (total_threads * buffer size)
-# (to avoid lctl ENOMEM problems)
-max_buffer_mem=$((256*1024))
-
-#####################################################################
-
-snap=1
-verify=1
-
-check_obdecho() {
-    lsmod | grep obdecho > /dev/null 2>&1
-}
-
-check_obdecho
-load_obdecho=$(($? != 0))
-
-if [ -z "$lustre_root" ]; then
-    lctl=lctl
-    if ((load_obdecho)); then
-       modprobe obdecho
-    fi
-else
-    lctl=${lustre_root}/lctl
-    if ((load_obdecho)); then
-       if [ -f ${lustre_root}/obdecho/obdecho.ko ]; then
-           insmod ${lustre_root}/obdecho/obdecho.ko
-       else
-           insmod ${lustre_root}/obdecho/obdecho.o
-       fi
-    fi
-fi
+thrlo=${thrlo:-1}
+thrhi=${thrhi:-16}
 
-check_obdecho || (echo "Can't load obdecho"; exit 1)
-
-get_devno () {
-    local type=$1
-    local name=$2
-    $lctl device_list | awk "{if (\$2 == \"UP\" && \$3 == \"$type\" && \$4 == \"$name\") {\
-                                print \$1; exit}}"
-}
-
-get_ec_devno () {
-    local idx=$1
-    local client_name=${client_names[idx]}
-    local ost_name=${ost_names[idx]}
-    if [ -z "$client_name" ]; then
-       if [ -z "$ost_name" ]; then
-           echo "client and ost name both null" 1>&2
-           return
-       fi
-       client_name=${ost_name}_echo_client
-    fi
-    ec=`get_devno echo_client $client_name`
-    if [ -n "$ec" ]; then
-       echo $ec $client_name 
-       return
-    fi
-    if [ -z "$ost_name" ]; then
-       echo "no echo client and ost_name not set" 1>&2
-       return
-    fi
-    ost=`get_devno obdfilter $ost_name`
-    if [ -z "$ost" ]; then
-       echo "OST $ost_name not setup" 1>&2
-       return
-    fi
-    $lctl <<EOF
-        attach echo_client $client_name ${client_name}_UUID
-       setup $ost_name
-EOF
-    ec=`get_devno echo_client $client_name`
-    if [ -z "$ec" ]; then
-       echo "Can't setup echo client" 1>&2
-       return
-    fi
-    echo $ec $client_name 1
-}
-
-teardown_ec_devno () {
-    local idx=$1
-    local client_name=${client_names[$idx]}
-    if ((do_teardown_ec[$idx])); then
-       $lctl <<EOF
-       cfg $client_name
-       cleanup
-       detach
-EOF
-   fi
-}
+# End of variables
 
+# create a set of objects, check there are 'n' contiguous ones and
+# return the first or 'ERROR'
+# parameter: 1. hostname
+#           2. device number
+#           3. number of object to be created (specified by user)
+#           4. tempfile name
 create_objects () {
-    # create a set of objects, check there are 'n' contiguous ones and
-    # return the first or 'ERROR'
-    local devno=$1
-    local nobj=$2
-    local rfile=$3
-    $lctl --device $devno create $nobj > $rfile 2>&1
-    n=(`awk < $rfile \
-       '/is object id/ {obj=strtonum($6);\
-                        first=!not_first; not_first=1;\
-                        if (first) first_obj=obj;
-                        else if (obj != prev + 1) exit;\
-                        prev=obj; n++}\
-            END {printf "%d %d\n", first_obj, n}'`)
-    if ((n[1] != nobj)); then
-       echo "ERROR"
-    else
-       echo ${n[0]}
+    local host=$1
+    local devno=$2
+    local nobj=$3
+    local rfile=$4
+    remote_shell $host $lctl --device $devno create $nobj > $rfile 2>&1
+    first=0
+    prev=0
+    count=0
+    error=0
+    while read line; do
+        echo "$line" | grep -q 'is object id'
+        if [ $?  -ne 0 ]; then
+            continue
+        fi
+        if [ $first -eq 0 ]; then
+            first=$(echo $line | awk '{print $6}')
+            first=$(printf "%d" $first)
+            prev=$first
+            count=1
+        else
+            obj=$(echo $line | awk '{print $6}') 
+            obj=$(printf "%d" $obj) 
+            diff=$((obj - (prev+1))) 
+            if [ $diff -ne 0 ]; then 
+                error=1 
+            fi 
+            prev=$obj 
+            count=$((count+1)) 
+        fi 
+    done < $rfile 
+    if [ $nobj -ne $count ]; then 
+        echo "ERROR: $nobj != $count" >&2 
+        cat $rfile >&2 
+        echo "ERROR" 
+    elif [ $error -ne 0 ]; then 
+        echo "ERROR: non contiguous objs found" >&2 
+    else 
+        echo $first 
     fi
 }
 
+# destroys all objects created in create_objects routine
+# parameter: 3. start obj id.
 destroy_objects () {
-    local devno=$1
-    local obj0=$2
-    local nobj=$3
-    local rfile=$4
-    $lctl --device $devno destroy $obj0 $nobj > $rfile 2>&1
+    local host=$1
+    local devno=$2
+    local obj0=$3
+    local nobj=$4
+    local rfile=$5
+    remote_shell $host $lctl --device $devno destroy $obj0 $nobj > $rfile 2>&1
 }
 
 get_stats () {
     local rfile=$1
-    awk < $rfile \
+    gawk < $rfile \
        '/^Selected device [0-9]+$/ {n = 0; next}\
        /error/ {n = -1; exit}\
        /^[0-9]+\/[0-9]+ Total: [0-9]+\.[0-9]+\/second$/ {n++; v=strtonum($3); \
@@ -184,6 +151,8 @@ get_global_stats () {
                       printf "%d %f %f\n", err, min, max}'
 }
 
+# enable or disable data check.
+# parameter: 1. read/write
 testname2type () {
     # 'x' disables data check
     if ((verify)); then
@@ -197,43 +166,227 @@ testname2type () {
     esac
 }
 
-start=`date +%F@%R`
-rsltf="${rslt}_${start}.summary"
-echo -n > $rsltf
-workf="${rslt}_${start}.detail"
-echo -n > $workf
-
 print_summary () {
     if [ "$1" = "-n" ]; then
-       minusn=$1; shift
+        minusn=$1; shift
     else
-       minusn=""
+        minusn=""
     fi
     echo $minusn "$*" >> $rsltf
     echo $minusn "$*"
 }
 
-ndevs=${#client_names[@]}
-if ((ndevs < ${#ost_names[@]} )); then
-    ndevs=${#ost_names[@]}
+# Customisation variables
+#####################################################################
+# One can change variable values in this section as per requirements
+
+targets=${targets:-""}
+case=${case:-"disk"}
+if [ -n "$targets" ]; then
+    declare -a ost_names
+    declare -a client_names
+    count=0
+    for name in $targets; do
+        if [ $case == "disk" ]; then
+            ost_names[$count]=$name
+        else
+            client_names[$count]=$name
+        fi
+        count=$((count+1))
+    done
 fi
 
-for ((idx = 0; idx < ndevs; idx++)); do
-    devno=(`get_ec_devno $idx`)
-    if ((${#devno[@]} < 2)); then
-       exit 1
+# what tests to run (first must be write)
+tests_str=${tests_str:-""}
+if [ -n "$tests_str" ]; then
+    declare -a tests
+    count=0
+    for name in $tests_str; do
+        tests[$count]=$name
+        count=$((count+1))
+    done
+else
+    #tests=(write rewrite read reread rewrite_again)
+    #tests=(write rewrite read)
+    tests=(write)
+fi
+
+# restart from here iff all are defined
+restart_rsz=
+restart_thr=1
+restart_nobj=1
+
+# machine's page size (K)
+if [ -z "$PAGE_SIZE" ]; then
+    if which python >/dev/null; then
+       PAGE_SIZE=`echo 'import resource; print resource.getpagesize()/1024;' |python`
     fi
-    devnos[$idx]=${devno[0]}
-    client_names[$idx]=${devno[1]}
-    do_teardown_ec[$idx]=$((${#devno[@]} > 2))
-done
+fi
+PAGE_SIZE=${PAGE_SIZE:-4}
 
-echo 0 > /proc/sys/portals/debug
+# max buffer_mem (total_threads * buffer size)
+# (to avoid lctl ENOMEM problems)
+max_buffer_mem=$((1024 * 1024))
+snap=1
+clean_srv_OSS=0
+# Customisation variables ends here. 
+#####################################################################
+# leave the rest of this alone unless you know what you're doing...
+
+# check and insert obdecho module
+if ! lsmod | grep obdecho > /dev/null; then
+    modprobe obdecho
+fi
+if [ ${#tests[@]} -eq 0 -o "${tests[0]}" != "write" ]; then
+    echo "tests: ${tests[@]}"
+    echo "First test must be 'write'" 1>&2
+    exit 1
+fi
+
+rsltf="${rslt}.summary"
+workf="${rslt}.detail"
+cmdsf="${rslt}.script"
+vmstatf="${rslt}.vmstat"
+echo -n > $rsltf
+echo -n > $workf
+
+# hide a little trick to unset this from the command line
+if [ "$lustre_root" == " " ]; then
+    unset lustre_root
+fi
 
-for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
-    for ((nobj=$nobjlo;nobj<=$nobjhi;nobj*=2)); do 
-       for ((thr=$thrlo;thr<=$thrhi;thr*=2)); do
-           if ((thr < nobj)); then
+if [ -z "$lustre_root" ]; then
+    lctl=lctl
+else
+    lctl=${lustre_root}/utils/lctl
+fi
+
+# split out hostnames from client/ost names
+ndevs=0
+for trgt in $targets; do
+    str=(`split_hostname $trgt`)
+    host_names[$ndevs]=${str[0]}
+    client_names[$ndevs]=${str[1]}
+    ndevs=$((ndevs+1))
+done
+if [ $case == "netdisk" ]; then
+    if [ "$targets" ]; then
+        for ((i = 0; i < $ndevs; i++)); do
+             setup_osc_for_remote_ost ${host_names[$i]} ${client_names[$i]} $i
+            cleanup_oscs="$cleanup_oscs ${client_names[$i]}_osc"
+            host_names[$i]=localhost
+        done
+    fi
+        declare -a osc_names
+        declare -a osc_uuids
+        osc_names_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$4} }")
+        count=0;
+        for name in $osc_names_str; do
+            osc_names[$count]=$name
+            count=$((count+1))
+        done
+        osc_uuid_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$5} }")
+        count=0;
+        for uuid in $osc_uuid_str; do
+            osc_uuids[$count]=$uuid
+            count=$((count+1))
+        done
+        for (( i = 0; i < $count; i++ ))
+        do
+            ec_using_osc ${osc_names[$i]}
+        done
+        echo_clients=$(lctl dl | grep echo_client | awk "{if (\$2 == \"UP\" && \$3 == \"echo_client\") {print \$4} }")
+        cnt=0;
+        for name in $echo_clients; do
+            client_names[$cnt]=$name
+            host_names[$cnt]=localhost
+            cnt=$((cnt+1))
+        done
+        ndevs=${#client_names[@]}
+fi
+if [ $case == "network" ]; then
+    server_nid=$targets
+    if [ -z "$server_nid" ]; then
+       echo "Specify hostname or ip-address of server"
+       exit 1;
+    fi
+    # check for obdecho module on server
+    if ! dsh $server_nid root "lsmod | grep obdecho > /dev/null"; then
+        dsh $server_nid root "modprobe obdecho"
+    fi
+    # Now do the server setup
+    setup_srv_obd $server_nid "echo_srv"
+    oss_on_srv=`dsh $server_nid root "lctl dl | grep OSS" | awk '{ print $4 }'`
+    if [ -z $oss_on_srv ]; then
+        setup_OSS $server_nid
+        clean_srv_OSS=1
+    fi
+    if ! dsh $server_nid root "lctl dl | grep obdecho > /dev/null 2>&1"; then
+        echo "obdecho not setup on server"
+        exit 1
+    fi
+    if ! dsh $server_nid root "lctl dl | grep ost > /dev/null 2>&1"; then
+        echo "ost not setup on server"
+        exit 1
+    fi
+    # Now start client setup
+    osc_names_str=$(lctl dl)
+    if [ -n "$osc_names_str" ]; then
+        echo "The existing setup must be cleaned";
+        exit 0;
+    fi
+    ec_using_srv_nid $server_nid "echotmp" "echotmp_UUID"
+    client_names[0]="echotmp_ecc"
+fi
+if [ -z "$targets" ]; then
+    if [ $case == "disk" ]; then
+       get_targets
+        ndevs=${#ost_names[@]} 
+    fi 
+fi
+# get vmstat started
+# disable portals debug and get obdecho loaded on all relevant hosts
+unique_hosts=(`unique ${host_names[@]}`)
+pidcount=0
+for host in ${unique_hosts[@]}; do
+    host_vmstatf=${vmstatf}_${host}
+    echo -n > $host_vmstatf
+    remote_shell $host "vmstat 5 >> $host_vmstatf" &
+    pid=$!
+    vmstatpids[$pidcount]=$pid
+    pidcount=$((pidcount+1))
+    do_unload_obdecho[$host]=0
+    if obdecho_loaded $host; then
+        continue
+    fi
+    load_obdecho $host
+    if obdecho_loaded $host; then
+        do_unload_obdecho[$host]=1
+        continue
+        fi
+    echo "Can't load obdecho on $host" 1>&2
+    exit 1
+done
+# get all the echo_client device numbers and names
+for ((i=0; i < $ndevs; i++)); do
+    host=${host_names[$i]}
+    devno=(`get_ec_devno $host "${client_names[$i]}" "${ost_names[$i]}"`)
+    if ((${#devno[@]} != 3)); then
+        exit 1
+    fi
+    devnos[$i]=${devno[0]}
+    client_names[$i]=${devno[1]}
+    do_teardown_ec[$i]=${devno[2]}
+done
+if (($ndevs <= 0 || ${#host_names[@]} <= 0)); then
+    echo "no devices or hosts specified"
+    cleanup 0 $clean_srv_OSS $cleanup_oscs
+fi
+print_summary "$(date) Obdfilter-survey for case=$case from $(hostname)"
+for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
+    for ((nobj = $nobjlo; nobj <= $nobjhi; nobj*=2)); do 
+       for ((thr = $thrlo; thr <= $thrhi; thr*=2)); do
+           if ((thr % nobj)); then
                continue
            fi
            # restart?
@@ -267,76 +420,114 @@ for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
            fi
            # create the objects
            tmpf="${workf}_tmp"
-           for ((idx=0; idx < ndevs; idx++)); do
+           for ((idx = 0; idx < $ndevs; idx++)); do
+               host=${host_names[$idx]}
                devno=${devnos[$idx]}
-               first_obj=`create_objects $devno $nobj $tmpf`
-               echo "========> Create [$idx]" >> $workf
+               client_name="${host}:${client_names[$idx]}"
+               echo "=============> Create $nobj on $client_name" >> $workf
+               first_obj=`create_objects $host $devno $nobj $tmpf`
                cat $tmpf >> $workf
                rm $tmpf
                if [ $first_obj = "ERROR" ]; then
-                   print_summary "created object #s [$idx] not contiguous"
+                   print_summary "created object #s on $client_name not contiguous"
                    exit 1
                fi
                first_objs[$idx]=$first_obj
            done
-           for test in write $tests; do
+           # run tests
+           for test in ${tests[@]}; do
+                declare -a pidarray
+                for host in ${unique_hosts[@]}; do
+                    echo "starting run for test: $test rsz: $rsz threads: $thr objects: $nobj" >> ${vmstatf}_${host}
+                done
                print_summary -n "$test "
-               t0=`date +%s.%N`
-               for ((idx=0; idx < ndevs; idx++)); do
+               # create per-host script files
+               for host in ${unique_hosts[@]}; do
+                   echo -n > ${cmdsf}_${host}
+               done
+               for ((idx = 0; idx < $ndevs; idx++)); do
+                   host=${host_names[$idx]}
                    devno=${devnos[$idx]}
                    tmpfi="${tmpf}_$idx"
                    first_obj=${first_objs[$idx]}
-                   $lctl > $tmpfi 2>&1 \
-                       --threads $thr -$snap $devno \
-                       test_brw $count `testname2type $test` q $pages ${thr}t${first_obj} &
-               done
-               wait
-               t1=`date +%s.%N`
+                   thr_per_obj=$((${thr}/${nobj}))
+                   echo >> ${cmdsf}_${host} \
+                       "$lctl > $tmpfi 2>&1 \\
+                         --threads $thr -$snap $devno \\
+                        test_brw $count `testname2type $test` q $pages ${thr_per_obj}t${first_obj} &"
+                done
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                    echo "wait" >> ${cmdsf}_${host}
+                    pidarray[$pidcount]=0
+                    pidcount=$((pidcount+1))
+                done
+                # timed run of all the per-host script files
+                t0=`date +%s.%N`
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                    remote_shell $host bash < ${cmdsf}_${host} &
+                    pidarray[$pidcount]=$!
+                    pidcount=$((pidcount+1))
+                done
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                    wait ${pidarray[$pidcount]}
+                    pidcount=$((pidcount+1))
+                done
+                #wait
+                t1=`date +%s.%N`
+                # clean up per-host script files
+                for host in ${unique_hosts[@]}; do
+                    rm ${cmdsf}_${host}
+                done
+               # compute bandwidth from total data / elapsed time
                str=`awk "BEGIN {printf \"%7.2f \",\
                         $total_size / (( $t1 - $t0 ) * 1024)}"`
                print_summary -n "$str"
+               # collect/check individual OST stats
                echo -n > $tmpf
-               for ((idx=0; idx < ndevs; idx++)); do
+               for ((idx = 0; idx < $ndevs; idx++)); do
+                   client_name="${host_names[$idx]}:${client_names[$idx]}"
                    tmpfi="${tmpf}_$idx"
-                   echo "========> $test [$idx]" >> $workf
-                   cat $tmpfi >> $workf
+                   echo "=============> $test $client_name" >> $workf
+                   host="${host_names[$idx]}"
+                   remote_shell $host cat $tmpfi >> $workf
                    get_stats $tmpfi >> $tmpf
                    rm $tmpfi
                done
-               echo "========> $test [$idx] global" >> $workf
+               # compute/display global min/max stats
+               echo "=============> $test global" >> $workf
                cat $tmpf >> $workf
                stats=(`get_global_stats $tmpf`)
                rm $tmpf
                if ((stats[0] <= 0)); then
                    if ((stats[0] < 0)); then
-                       str=`printf "%15s " ERROR`
+                       str=`printf "%17s " ERROR`
                    else
-                       str=`printf "%15s " SHORT`
+                       str=`printf "%17s " SHORT`
                    fi
                else
-                   str=`awk "BEGIN {printf \"[%6.2f,%6.2f] \",\
+                   str=`awk "BEGIN {printf \"[%7.2f,%7.2f] \",\
                             (${stats[1]} * $actual_rsz)/1024,\
                             (${stats[2]} * $actual_rsz)/1024; exit}"`
                fi
                print_summary -n "$str"
            done
            print_summary ""
-           for ((idx=0; idx < ndevs; idx++)); do
+           # destroy objects we created
+           for ((idx = 0; idx < $ndevs; idx++)); do
+               host=${host_names[$idx]}
                devno=${devnos[$idx]}
+               client_name="${host}:${client_names[$idx]}"
                first_obj=${first_objs[$idx]}
-               destroy_objects $devno $first_obj $nobj $tmpf
-               echo "========> Destroy [$idx]" >> $workf
+               echo "=============> Destroy $nobj on $client_name" >> $workf
+               destroy_objects $host $devno $first_obj $nobj $tmpf
                cat $tmpf >> $workf
                rm $tmpf
            done
        done
     done
 done
-
-for ((idx=0; idx < ndevs; idx++)); do
-    teardown_ec_devno $idx
-done
-
-if ((load_obdecho)); then
-    rmmod obdecho
-fi
+cleanup 0 $clean_srv_OSS $cleanup_oscs
+exit 0